const { app, BrowserWindow, shell, Menu, dialog } = require("electron");
const path = require("path");
let mainWindow;
var openWindows = 0;

let pluginName
switch (process.platform) {
  case 'win32':
    pluginName = 'pepflashplayer.dll'
    break
  case 'darwin':
    pluginName = 'PepperFlashPlayer.plugin'
    break
  case 'linux':
    pluginName = 'libpepflashplayer.so'
    break
}
app.commandLine.appendSwitch('ppapi-flash-path', path.join(__dirname, pluginName));
app.commandLine.appendSwitch('ppapi-flash-version', '17.0.0.169');

app.on("ready", () => {
	mainWindow = openGameWindow();
});
app.on("before-quit", () => {
	//shell.openExternal("http://oldcp.biz/closed");
});

function openGameWindow() {
	var window = new BrowserWindow({
		width: 980,
		height: 620,
		allowRunningInsecureContent: true,
		webPreferences: {
	      plugins: true
	    },
	    useContentSize: true
	});
	window.on("close", () => {
		openWindows--;
		if(openWindows <= 0)
			app.quit();
    });
    setMainMenu(window);
	window.loadURL(path.join("file://", __dirname, "index.html"));
	
	openWindows++;
	
	return window;
}
function setMainMenu() {
	var template = [
	{
		label: "OldCP Cinema Mode",
		submenu: [{
			label: 'Quit',
			accelerator: 'Cmd+Q',
			click() {
				app.quit();
			}
		},
		{
			label: 'Visit Forums',
			click() {
				shell.openExternal("https://forums.damenspike.com");
			}
		},
		{
			label: 'Official Site',
			click() {
				shell.openExternal("https://oldcp.biz");
			}
		},
		{
			label: 'Other Games',
			click() {
				shell.openExternal("https://damenspike.com");
			}
		}]
	},
	{
		label: "Game",
		submenu: [
		{
			label: 'New Game',
			click() {
				openGameWindow();
			}
		},
		{
			label: 'Relogin',
			accelerator: 'Cmd+R',
			click() {
				var activeWindow = BrowserWindow.getFocusedWindow();
				if(!activeWindow) {
					return;
				}
				activeWindow.webContents.executeJavaScript("relogin();");
			}
		},
		{
			label: 'Clear Cache',
			click() {
				clearCache();
			}
		}]
	}];
	Menu.setApplicationMenu(Menu.buildFromTemplate(template));
}
function clearCache() {
	const win = BrowserWindow.getAllWindows()[0];
	const ses = win.webContents.session;
	
	ses.clearCache(() => {
		alert("Cache cleared");
	});
}
function alert(message) {
	var activeWindow = BrowserWindow.getFocusedWindow();
	if(!activeWindow) {
		return;
	}
	dialog.showMessageBox(activeWindow, {type: 'info', title: 'Alert', message: message, buttons: ['OK']});
}